#!/bin/bash

# Aktualizace a upgrade
echo "Aktualizuji a upgraduji server..."
apt-get update && apt-get upgrade -y

# Změna hesla root
echo "Změna hesla pro root..."
passwd

# Vytvoření uživatele
echo -n "Zadejte jméno nového uživatele: "
read new_user
adduser "$new_user"

# Instalace a konfigurace sudo, pokud není nainstalováno
if [ ! -x "$(command -v sudo)" ]; then
    echo "Instaluji sudo..."
    apt-get install sudo -y
fi

# Přidání uživatele do skupiny sudo
echo "Přidávám uživatele do skupiny sudo..."
usermod -aG sudo "$new_user"

# Nastavení SSH klíče
echo "Chcete nahrát SSH klíč pro nového uživatele? (y/n)"
read upload_key
if [ "$upload_key" = "y" ]; then
    echo "Vložte veřejný SSH klíč jako text:"
    read ssh_key
    mkdir -p /home/"$new_user"/.ssh
    echo "$ssh_key" > /home/"$new_user"/.ssh/authorized_keys
    chmod 700 /home/"$new_user"/.ssh
    chmod 600 /home/"$new_user"/.ssh/authorized_keys
    chown -R "$new_user":"$new_user" /home/"$new_user"/.ssh
    echo "SSH klíč byl nahrán a nastaven."
else
    echo "Nahrání SSH klíče bylo přeskočeno."
fi

# Konfigurace SSH daemonu
echo "Konfiguruji SSH daemon..."
echo "PubkeyAuthentication yes" >> /etc/ssh/sshd_config
echo "AuthorizedKeysFile .ssh/authorized_keys" >> /etc/ssh/sshd_config

# Restart SSH služby
echo "Restartuji SSH službu..."
systemctl restart sshd

echo "Skript dokončen!"
